/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 */
package blanco.omegat.util.task;

import java.io.IOException;

import blanco.omegat.util.task.valueobject.BlancoOmegatTranslateXliffProcessInput;

/**
 * バッチ処理クラス [BlancoOmegatTranslateXliffBatchProcess]。
 *
 * <P>バッチ処理の呼び出し例。</P>
 * <code>
 * java -classpath (クラスパス) blanco.omegat.util.task.BlancoOmegatTranslateXliffBatchProcess -help
 * </code>
 */
public class BlancoOmegatTranslateXliffBatchProcess {
    /**
     * 正常終了。
     */
    public static final int END_SUCCESS = 0;

    /**
     * 入力異常終了。内部的にjava.lang.IllegalArgumentExceptionが発生した場合。
     */
    public static final int END_ILLEGAL_ARGUMENT_EXCEPTION = 7;

    /**
     * 入出力例外終了。内部的にjava.io.IOExceptionが発生した場合。
     */
    public static final int END_IO_EXCEPTION = 8;

    /**
     * 異常終了。バッチの処理開始に失敗した場合、および内部的にjava.lang.Errorまたはjava.lang.RuntimeExceptionが発生した場合。
     */
    public static final int END_ERROR = 9;

    /**
     * コマンドラインから実行された際のエントリポイントです。
     *
     * @param args コンソールから引き継がれた引数。
     */
    public static final void main(final String[] args) {
        final BlancoOmegatTranslateXliffBatchProcess batchProcess = new BlancoOmegatTranslateXliffBatchProcess();

        // バッチ処理の引数。
        final BlancoOmegatTranslateXliffProcessInput input = new BlancoOmegatTranslateXliffProcessInput();

        boolean isNeedUsage = false;
        boolean isFieldTmxdirProcessed = false;

        // コマンドライン引数の解析をおこないます。
        for (int index = 0; index < args.length; index++) {
            String arg = args[index];
            if (arg.startsWith("-verbose=")) {
                input.setVerbose(Boolean.valueOf(arg.substring(9)).booleanValue());
            } else if (arg.startsWith("-tmxdir=")) {
                input.setTmxdir(arg.substring(8));
                isFieldTmxdirProcessed = true;
            } else if (arg.startsWith("-xliffdir=")) {
                input.setXliffdir(arg.substring(10));
            } else if (arg.startsWith("-xlifffile=")) {
                input.setXlifffile(arg.substring(11));
            } else if (arg.startsWith("-tool-id=")) {
                input.setToolId(arg.substring(9));
            } else if (arg.startsWith("-origin=")) {
                input.setOrigin(arg.substring(8));
            } else if (arg.startsWith("-skipiftargetexist=")) {
                input.setSkipiftargetexist(Boolean.valueOf(arg.substring(19)).booleanValue());
            } else if (arg.equals("-?") || arg.equals("-help")) {
                usage();
                System.exit(END_SUCCESS);
            } else {
                System.out.println("BlancoOmegatTranslateXliffBatchProcess: 入力パラメータ[" + arg + "]は無視されました。");
                isNeedUsage = true;
            }
        }

        if (isNeedUsage) {
            usage();
        }

        if( isFieldTmxdirProcessed == false) {
            System.out.println("BlancoOmegatTranslateXliffBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[tmxdir]に値が設定されていません。");
            System.exit(END_ILLEGAL_ARGUMENT_EXCEPTION);
        }

        int retCode = batchProcess.execute(input);

        // 終了コードを戻します。
        // ※注意：System.exit()を呼び出している点に注意してください。
        System.exit(retCode);
    }

    /**
     * 具体的なバッチ処理内容を記述するためのメソッドです。
     *
     * このメソッドに実際の処理内容を記述します。
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IOException 入出力例外が発生した場合。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public int process(final BlancoOmegatTranslateXliffProcessInput input) throws IOException, IllegalArgumentException {
        // 入力パラメータをチェックします。
        validateInput(input);

        // この箇所でコンパイルエラーが発生する場合、BlancoOmegatTranslateXliffProcessインタフェースを実装して blanco.omegat.util.taskパッケージに BlancoOmegatTranslateXliffProcessImplクラスを作成することにより解決できる場合があります。
        final BlancoOmegatTranslateXliffProcess process = new BlancoOmegatTranslateXliffProcessImpl();

        // 処理の本体を実行します。
        final int retCode = process.execute(input);

        return retCode;
    }

    /**
     * クラスをインスタンス化してバッチを実行する際のエントリポイントです。
     *
     * このメソッドは下記の仕様を提供します。
     * <ul>
     * <li>メソッドの入力パラメータの内容チェック。
     * <li>IllegalArgumentException, RuntimeException, Errorなどの例外をcatchして戻り値へと変換。
     * </ul>
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public final int execute(final BlancoOmegatTranslateXliffProcessInput input) throws IllegalArgumentException {
        try {
            // バッチ処理の本体を実行します。
            int retCode = process(input);

            return retCode;
        } catch (IllegalArgumentException ex) {
            System.out.println("BlancoOmegatTranslateXliffBatchProcess: 入力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_ILLEGAL_ARGUMENT_EXCEPTION;
        } catch (IOException ex) {
            System.out.println("BlancoOmegatTranslateXliffBatchProcess: 入出力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_IO_EXCEPTION;
        } catch (RuntimeException ex) {
            System.out.println("BlancoOmegatTranslateXliffBatchProcess: ランタイム例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            ex.printStackTrace();
            // 異常終了。
            return END_ERROR;
        } catch (Error er) {
            System.out.println("BlancoOmegatTranslateXliffBatchProcess: ランタイムエラーが発生しました。バッチ処理を中断します。:" + er.toString());
            er.printStackTrace();
            // 異常終了。
            return END_ERROR;
        }
    }

    /**
     * このバッチ処理クラスの使い方の説明を標準出力に示すためのメソッドです。
     */
    public static final void usage() {
        System.out.println("BlancoOmegatTranslateXliffBatchProcess: Usage:");
        System.out.println("  java blanco.omegat.util.task.BlancoOmegatTranslateXliffBatchProcess -verbose=値1 -tmxdir=値2 -xliffdir=値3 -xlifffile=値4 -tool-id=値5 -origin=値6 -skipiftargetexist=値7");
        System.out.println("    -verbose");
        System.out.println("      説明[verboseモードで動作させるかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[false]");
        System.out.println("    -tmxdir");
        System.out.println("      説明[TMX ファイルが格納されているディレクトリ。]");
        System.out.println("      型[文字列]");
        System.out.println("      必須パラメータ");
        System.out.println("    -xliffdir");
        System.out.println("      説明[入力・出力先となる OASIS XLIFF ファイルが格納されるディレクトリ。xlifffileと排他利用。]");
        System.out.println("      型[文字列]");
        System.out.println("    -xlifffile");
        System.out.println("      説明[入力・出力先となる OASIS XLIFF ファイル。xliffdir と排他利用。]");
        System.out.println("      型[文字列]");
        System.out.println("    -tool-id");
        System.out.println("      説明[ツールID。]");
        System.out.println("      型[文字列]");
        System.out.println("      デフォルト値[omegat]");
        System.out.println("    -origin");
        System.out.println("      説明[翻訳メモリの出所。]");
        System.out.println("      型[文字列]");
        System.out.println("    -skipiftargetexist");
        System.out.println("      説明[targetが既にある場合に処理をスキップするかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[false]");
        System.out.println("    -? , -help");
        System.out.println("      説明[使い方を表示します。]");
    }

    /**
     * このバッチ処理クラスの入力パラメータの妥当性チェックを実施するためのメソッドです。
     *
     * @param input バッチ処理の入力パラメータ。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public void validateInput(final BlancoOmegatTranslateXliffProcessInput input) throws IllegalArgumentException {
        if (input == null) {
            throw new IllegalArgumentException("BlancoBatchProcessBatchProcess: 処理開始失敗。入力パラメータ[input]にnullが与えられました。");
        }
        if (input.getTmxdir() == null) {
            throw new IllegalArgumentException("BlancoOmegatTranslateXliffBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[tmxdir]に値が設定されていません。");
        }
    }
}
